"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = featureContent;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var React = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _reactRedux = require("react-redux");

var _reselect = require("reselect");

function featureContent(options) {
  var _defaults = (0, _lodash.defaults)({}, options, {
    getFeatures: function getFeatures(state) {
      return state ? state.features : {};
    },
    sortFeatures: function sortFeatures(features) {
      return Object.values(features);
    }
  }),
      getFeatures = _defaults.getFeatures,
      sortFeatures = _defaults.sortFeatures,
      getContent = _defaults.getContent;

  var mapStateToProps = (0, _reselect.createStructuredSelector)({
    features: (0, _reselect.createSelector)(getFeatures, sortFeatures)
  });

  function mergeProps(_ref2, dispatchProps, _ref) {
    var features = _ref2.features;
    var children = _ref.children,
        props = (0, _objectWithoutProperties2.default)(_ref, ["children"]);
    var content = [];
    features.forEach(function (feature, featureIndex) {
      var featureContent = getContent(feature);
      if (featureContent == null) return;
      if (typeof featureContent === 'function') featureContent = featureContent(props);
      if (!Array.isArray(featureContent)) featureContent = [featureContent];
      featureContent.forEach(function (item, index) {
        if (React.isValidElement(item) && item.key == null) {
          item = React.cloneElement(item, {
            key: featureIndex + ':' + index
          });
        }

        content.push(item);
      });
    });
    return {
      children: children instanceof Function ? children(content) : React.createElement(React.Fragment, null, content)
    };
  }

  var FeatureContent = function FeatureContent(_ref3) {
    var children = _ref3.children;
    return children;
  };

  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureContent);
}